// $Date:: 2014-07-27 02:52:58 +0900#$
// $Rev: 11 $


#pragma once
#include <windows.h>
#include <stdint.h>
#include "avisynth.h"

namespace convert8to16_nosse
{
	//==============================================================================
	// Convert8to16
	//==============================================================================
	class Convert8to16 : public GenericVideoFilter
	{
	private:
		uint16_t* v1 = NULL;
		uint8_t* v2 = NULL;
		uint16_t* v3 = NULL;
		uint16_t* v4 = NULL;
		uint32_t* v5 = NULL;
		uint32_t* v6 = NULL;
		uint16_t* v7 = NULL;

	protected:
		uint32_t BuffSize;
		const uint32_t Span;
		const uint32_t YThr;
		const uint32_t CThr;
		const uint32_t Mode;
		const bool Debug;

		void SetPixcel(PVideoFrame & src, PVideoFrame & dst, uint32_t nPlanar);

	public:
		Convert8to16(PClip _child, IScriptEnvironment* env, const uint32_t span, const uint32_t ythr, const uint32_t cthr, uint32_t mode, bool debug);
		virtual ~Convert8to16();
		virtual PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env);
	};
}
